模板名稱
ACS-ECS-ConfigurePackage 大量安裝或卸載包
模板描述
使用這個模板批量的在ECS安裝或卸載yum/apt包
模板類型
自動化
所有者
Alibaba Cloud
輸入參數
參數名稱 | 描述 | 類型 | 是否必填 | 預設值 | 約束 |
action | 操作類型 | String | 是 | ||
targets | 目標執行個體 | Json | 是 | ||
packageName | yum/apt-get安裝的包名 | String | 是 | ||
regionId | 地區ID | String | 否 | {{ ACS::RegionId }} | |
installer | 安裝源 | String | 否 | apt-get | |
rateControl | 任務執行的並發比率 | Json | 否 | {‘Mode’: ‘Concurrency’, ‘MaxErrors’: 0, ‘Concurrency’: 10} | |
OOSAssumeRole | OOS扮演的RAM角色 | String | 否 | “” |
輸出參數
參數名稱 | 描述 | 類型 |
commandOutput | String |
執行此模板需要的權限原則
{
"Version": "1",
"Statement": [
{
"Action": [
"ecs:DescribeInstances",
"ecs:DescribeInvocationResults",
"ecs:DescribeInvocations",
"ecs:RunCommand"
],
"Resource": "*",
"Effect": "Allow"
}
]
}
詳情
模板內容
FormatVersion: OOS-2019-06-01
Description:
en: Use this template to install or unistall package on ecs
zh-cn: 使用這個模板批量的在ECS安裝或卸載yum/apt包
name-en: ACS-ECS-ConfigurePackage
name-zh-cn: 大量安裝或卸載包
categories:
- run_command
Parameters:
regionId:
Type: String
Label:
en: RegionId
zh-cn: 地區ID
AssociationProperty: RegionId
Default: '{{ ACS::RegionId }}'
installer:
Type: String
Label:
en: Installer
zh-cn: 安裝源
Default: apt-get
AllowedValues:
- apt-get
- yum
action:
Type: String
Label:
en: Action
zh-cn: 操作類型
AllowedValues:
- install
- uninstall
targets:
Type: Json
Label:
en: TargetInstance
zh-cn: 目標執行個體
AssociationProperty: Targets
AssociationPropertyMetadata:
ResourceType: 'ALIYUN::ECS::Instance'
RegionId: regionId
packageName:
Type: String
Label:
en: PackageName
zh-cn: yum/apt-get安裝的包名
rateControl:
Label:
en: RateControl
zh-cn: 任務執行的並發比率
Type: Json
AssociationProperty: RateControl
Default:
Mode: Concurrency
MaxErrors: 0
Concurrency: 10
OOSAssumeRole:
Label:
en: OOSAssumeRole
zh-cn: OOS扮演的RAM角色
Type: String
Default: ''
RamRole: '{{ OOSAssumeRole }}'
Tasks:
- Name: getInstance
Description:
en: Views the ECS instances
zh-cn: 擷取ECS執行個體
Action: 'ACS::SelectTargets'
Properties:
ResourceType: 'ALIYUN::ECS::Instance'
RegionId: '{{ regionId }}'
Filters:
- '{{ targets }}'
Outputs:
instanceIds:
Type: List
ValueSelector: 'Instances.Instance[].InstanceId'
- Name: runCommand
Action: 'ACS::ECS::RunCommand'
Properties:
commandContent: |-
#!/bin/bash
if [ "{{installer}}" = "yum" ]; then
if [ "{{action}}" = "install" ]; then
yum install -y {{packageName}}
if [ $? -ne 0 ]; then
echo "Package is install failed. Please check your command" >&2;
exit 1;
fi
exit 0;
elif [ "{{action}}" = "uninstall" ]; then
yum remove -y {{packageName}}
if [ $? -ne 0 ]; then
echo "Package uninstall failed. Please check your command" >&2;
exit 1;
fi
exit 0;
else
echo "Package command must be install or uninstall" >& 2
exit 1;
fi
elif [ "{{installer}}" = "apt-get" ]; then
if [ "{{action}}" = "install" ]; then
apt-get -y install {{packageName}}
if [ $? -ne 0 ]; then
echo "Package is install failed. Please check your command" >&2;
exit 1;
fi
exit 0;
elif [ "{{action}}" = "uninstall" ]; then
apt-get -y remove {{packageName}}
if [ $? -ne 0 ]; then
echo "Package uninstall failed. Please check your command" >&2;
exit 1;
fi
exit 0;
else
echo "Package command must be install or uninstall" >& 2
exit 1;
fi
else
echo "Unknown pakcage installer. Only support yum/apt-get" >&2;
exit 1;
fi
instanceId: '{{ ACS::TaskLoopItem }}'
regionId: '{{ regionId }}'
commandType: RunShellScript
Loop:
Items: '{{ getInstance.instanceIds }}'
RateControl: '{{ rateControl }}'
Outputs:
commandOutputs:
AggregateType: 'Fn::ListJoin'
AggregateField: commandOutput
Outputs:
commandOutput:
Type: String
ValueSelector: invocationOutput
Outputs:
commandOutput:
Type: String
Value: '{{ runCommand.commandOutputs }}'
Metadata:
ALIYUN::OOS::Interface:
ParameterGroups:
- Parameters:
- installer
- action
- packageName
Label:
default:
zh-cn: 設定參數
en: Configure Parameters
- Parameters:
- regionId
- targets
Label:
default:
zh-cn: 選擇執行個體
en: Select Ecs Instances
- Parameters:
- rateControl
- OOSAssumeRole
Label:
default:
zh-cn: 進階選項
en: Control Options